local addon, shared = ...
local id = addon.identifier

local playerName = nil

_CQTimer = { UI={} }

local CQ = _CQTimer

local default_settings = {
	mmx = 400, mmy = 400
	}

local default_settingsAC = {
	STILLMOOR_TIMER_CQ=0, STILLMOOR_TIMER_NX=0
}
	
local CQACTIVE = false
local CQTIME = 0
local last_update = 0
local last_actcheck=0
local SVLOADED = false

local msg_active = false
local msg_time = 0
	
local function MergeTable(o,n)
	for k,v in pairs(n) do
		if type(v) == "table" then
			if o[k] == nil then
				o[k] = {}			
			end
	 	 	if type(o[k]) == 'table' then
	 			MergeTable(o[k], n[k])
	 	 	end
		else
			if o[k] == nil then
				o[k] = v
			end
		end
	end
end

function CQ.Event_Chat_Notify(i)
	if i.message == "Stillmoor has been Conquered!" then
		CQTimer_SettingsAC.STILLMOOR_TIMER_CQ = Inspect.Time.Server()
		CQTimer_SettingsAC.STILLMOOR_TIMER_NX = CQTimer_SettingsAC.STILLMOOR_TIMER_CQ+4260
--		print(string.format("%s : %d", i.message, CQTimer_SettingsAC.STILLMOOR_TIMER_CQ))
		CQACTIVE = true
	end
end

function CQ.FormatTime(t)
	local h = 0
	local m = 0
	local s = 0
	
	h = math.floor(t/3600)
	t=t-(h*3600)
	m = math.floor(t/60)
	s = t-(m*60)
	
	return(string.format("%d:%02d:%02d", h,m,s))
end

function CQ.Event_Addon_SavedVariables_Load_End(a)
	if a == addon.identifier then
		if CQTimer_Settings == nil then CQTimer_Settings = {} end
		if CQTimer_SettingsAC == nil then CQTimer_SettingsAC = {} end
		
		MergeTable(CQTimer_Settings, default_settings)
		MergeTable(CQTimer_SettingsAC, default_settingsAC)
		
		CQ.UI.button:SetPoint("TOPLEFT", UIParent, "TOPLEFT", CQTimer_Settings.mmx, CQTimer_Settings.mmy)
		
		if CQTimer_SettingsAC.STILLMOOR_TIMER_NX > Inspect.Time.Server() then
			CQACTIVE = true
		else
--			print("Seeking update!")
			Command.Message.Broadcast("guild", nil, "ACQT", string.format("CQTIMREQ"))
			last_actcheck = Inspect.Time.Server()
		end
		SVLOADED = true
		playerName = Inspect.Unit.Detail("player").name
	end
end

function CQ.BuildUI()
	CQ.UI.context = UI.CreateContext(addon.identifier)
	CQ.UI.button = UI.CreateFrame("Texture", "CQ.UI.button", CQ.UI.context)
	CQ.UI.button:SetHeight(32)
	CQ.UI.button:SetWidth(32)
	CQ.UI.button:SetLayer(1)
	CQ.UI.button:SetTexture(addon.identifier, "img/conquest.png")
	CQ.UI.text = UI.CreateFrame("Text", "CQ.UI.text", CQ.UI.button)
	CQ.UI.text:SetFontSize(16)
	CQ.UI.text:SetPoint("CENTERLEFT", CQ.UI.button, "CENTERRIGHT", 2,0)
	CQ.UI.text:SetText("Active/Unknown")
	
	function CQ.UI.button.Event:LeftDown()
		self.MouseDown = true
		local mouseData = Inspect.Mouse()
		self.sx = mouseData.x - CQ.UI.button:GetLeft()
		self.sy = mouseData.y - CQ.UI.button:GetTop()		
	end

	function CQ.UI.button.Event:LeftUp()
		self.MouseDown = false
		CQTimer_Settings.mmx = CQ.UI.button:GetLeft()
		CQTimer_Settings.mmy = CQ.UI.button:GetTop()
	end

	function CQ.UI.button.Event:MouseMove()
		if self.MouseDown then
			local nx, ny
			local mouseData = Inspect.Mouse()
			nx = mouseData.x - self.sx
			ny = mouseData.y - self.sy
			CQ.UI.button:SetPoint("TOPLEFT", UIParent, "TOPLEFT", nx,ny)
		end
	end
	
end

function CQ.Event_System_Update_Begin()
	if CQACTIVE then
		local ut = Inspect.Time.Server()
		if ut > last_update then
			last_update = ut
			CQTIME = CQTimer_SettingsAC.STILLMOOR_TIMER_NX - ut
			if CQTIME > 0 then
				CQ.UI.text:SetText(string.format("Time: %s", CQ.FormatTime(CQTIME)))
			else
				CQ.UI.text:SetText("Active/Unknown")
				CQACTIVE = false
			end
		end
	elseif SVLOADED then
		local ut = Inspect.Time.Server()
		if ut - last_actcheck > 60 then
			last_actcheck = ut
--			print("Seeking update!")
			CQ.SendAddonMessage("CQTIMREQ")
		end
		if msg_active then
			if ut - msg_time > 5 then
				msg_active = false
				msg_time = 0
--				print(">5s closing down listen")
			end
		end
	end
end

--/script Command.Message.Broadcast("tell", "Adelea", "ACQT", string.format("TIMELEFT=%d",1360256721 - Inspect.Time.Server()))

-- /script print(1360256721 - Inspect.Time.Server())

-- /script _CQTimer.SendAddonMessage("CQTIMREQ")
function CQ.Event_Message_Receive(f,t,c,i,d)
	if i=="ACQT" then
		if f ~= playerName then
--			print(string.format("f=%s [YOURSELF], t=%s, i=%s, d=%s", f,t,i,d))
--		else
			print(string.format("f=%s, t=%s, i=%s, d=%s", f,t,i,d))
--		end
			if d=="CQTIMREQ" then
				if CQACTIVE then
					local ut = Inspect.Time.Server()
					local cqt= CQTimer_SettingsAC.STILLMOOR_TIMER_NX - ut
--					print(string.format("Send reply to %s, time=%d", f, cqt))
					Command.Message.Broadcast("tell", f, "ACQT", string.format("TIMELEFT=%d",cqt))
				end
			elseif string.sub(d,1,8) == "TIMELEFT" and msg_active then
				local tr = tonumber(string.sub(d,10))
				if tr then
					CQACTIVE=true
					CQTimer_SettingsAC.STILLMOOR_TIMER_NX = Inspect.Time.Server() + tr
--					print(string.format("CQ in %d seconds!", tr))
--				else
--					print("Invalid number: "..d)
				end
			end
		end
	end
end

CQ.BuildUI()

function CQ.SendAddonMessage(m)
	msg_active = true
	msg_time = Inspect.Time.Server()
	Command.Message.Broadcast("guild", nil, "ACQT", m)
	Command.Message.Broadcast("party", nil, "ACQT", m)
	Command.Message.Broadcast("raid", nil, "ACQT", m)
	Command.Message.Broadcast("say", nil, "ACQT", m)
	Command.Message.Broadcast("yell", nil, "ACQT", m)
	Command.Message.Broadcast("channel", "addons", "ACQT", m)
end

table.insert(Event.Chat.Notify, { CQ.Event_Chat_Notify, addon.identifier, "Event.Chat.Notify"})
table.insert(Event.Addon.SavedVariables.Load.End, {CQ.Event_Addon_SavedVariables_Load_End, addon.identifier, "Event.Addon.SavedVariables.Load.End" })
table.insert(Event.System.Update.Begin, { CQ.Event_System_Update_Begin, addon.identifier, "Event.System.Update.Begin" })
table.insert(Event.Message.Receive, { CQ.Event_Message_Receive, addon.identifier, "Event.Message.Receive"})

Command.Message.Accept("guild", "ACQT")
Command.Message.Accept("channel", "ACQT")
Command.Message.Accept("party", "ACQT")
Command.Message.Accept("raid", "ACQT")
Command.Message.Accept("say", "ACQT")
Command.Message.Accept("yell", "ACQT")
Command.Message.Accept("tell", "ACQT")
